{
<EVENT NAME="" PARAMETERS="" RETURN="[blank for procedural, type if functional]" />

* I removed the VARPARAMETERS because I think the RPC mechanism will be intelligent and
specific enough to handle that... so you just declare:
PARAMETERS="x:integer;VAR allow:boolean;"
}
unit preprocessevents;
interface
uses classes,lowx,sysutils;

function processEventsTypeDeclarations (EventList:TStringlist):String;
function produceEventsTypeDeclarations (Data:String):String;
function produceEventsPrivateStatement (Data:String):String;
function produceEventsPublishedStatement (Data:String):String;

implementation


function processEventsTypeDeclarations (EventList:TStringlist):String;
var i:integer;
    outhold,thisevent,eName,eParm,eParen,
    eReturn,eProc,evars,eFuncResult:String;
    isproc:boolean;
begin
outhold:='';
 {accepts a stringlist of event tags and generates he type declarations
  T[EventType] = [procedure|function]([params&Varparams])[:ReturnType] of object;
 }
for i:= 0 to EventList.count-1 do
 begin
  thisevent:=Eventlist[i];
  eName:=GetTagProperty (thisevent,'EVENT','NAME');

 {Be nice and accept 2 forms for the parameter list}
  eParm:=GetTagProperty (thisevent,'EVENT','PARAMETERS');
  eParm:=eParm + GetTagProperty (thisevent,'EVENT','PARAMS');

  eReturn:=GetTagProperty (thisevent,'EVENT','RETURN');

  eProc:='procedure';
  eFuncResult:='';
  if trim(eReturn)<>'' then 
  		begin
		 eProc:='function';
		 eFuncResult:=eReturn;
		end;
  
 if eParm<>'' then eParen:='('+eParm+')' ;
  outhold:=outhold+' T'+eName+' = '+eProc+eParen+ eFuncResult + ' of object;'  +#13+#10
 end;
result:=outhold;
end;

function processEventsPrivateStatement (EventList:TStringlist):String;
var i:integer;
    outhold,thisevent,eName,eParm,
    eReturn,eProc,evars,eFuncResult:String;
    isproc:boolean;
begin
outhold:='';
  {
  accepts a stringlist of event tags and generates the 
  private declaration of the properties
  f[EventName]:T[EventType];
 }
for i:= 0 to EventList.count-1 do
 begin
  thisevent:=Eventlist[i];
  eName:=GetTagProperty (thisevent,'EVENT','NAME');
  outhold:=outhold+'  f'+eName+' : T'+eName +' ;' +#13+#10
 end;
result:=outhold;
end;

function processEventsPublishedStatement (EventList:TStringlist):String;
var i:integer;
    outhold,thisevent,eName,eParm,
    eReturn,eProc,evars,eFuncResult:String;
    isproc:boolean;
begin
outhold:='';
   {
  accepts a stringlist of event tags and generates the 
  published event properties connecting to the private vars above

  property [EventName]:T[EventType] read f[EventName] write f[EventName];
 }
for i:= 0 to EventList.count-1 do
 begin
  thisevent:=Eventlist[i];
  eName:=GetTagProperty (thisevent,'EVENT','NAME');
 

  outhold:=outhold+' property '+eName+' : T'+eName+' read f'+eName+' write f'+eName+' ;'+#13+#10
 end;
result:=outhold;
end;

function produceEventsTypeDeclarations (Data:String):String;
var feventlist:tstringlist;
begin
 feventlist:=tstringlist.create;
 feventlist:=GetTermTagList(Data,'EVENT');
 result:=processEventsTypeDeclarations(feventlist);
 feventlist.clear;
 feventlist.free;
end;

function produceEventsPrivateStatement (Data:String):String;
var feventlist:tstringlist;
begin
 feventlist:=tstringlist.create;
 feventlist:=GetTermTagList(Data,'EVENT');
 result:=processEventsPrivateStatement(feventlist);
 feventlist.clear;
 feventlist.free;
end;

function produceEventsPublishedStatement (Data:String):String;
var feventlist:tstringlist;
begin
 feventlist:=tstringlist.create;
 feventlist:=GetTermTagList(Data,'EVENT');
 result:=processEventsPublishedStatement(feventlist);
 feventlist.clear;
 feventlist.free;
end;

end.
